Bullet Collision Detection & Physics Library: btDeformableMousePickingForce Class Reference

Bullet Collision Detection & Physics Library

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Private Attributes | List of all members
btDeformableMousePickingForce Class Reference

`#include <btDeformableMousePickingForce.h>`

Inheritance diagram for btDeformableMousePickingForce:
[legend]
Collaboration diagram for btDeformableMousePickingForce:
[legend]

## Public Types
typedef btAlignedObjectArray< btVector3 > | TVStack
Public Types inherited from btDeformableLagrangianForce
typedef btAlignedObjectArray< btVector3 > | TVStack

## Public Member Functions
| btDeformableMousePickingForce (btScalar k, btScalar d, const btSoftBody::Face &face, const btVector3 &mouse_pos, btScalar maxForce=0.3)
virtual void | addScaledForces (btScalar scale, TVStack &force)
virtual void | addScaledExplicitForce (btScalar scale, TVStack &force)
virtual void | addScaledDampingForce (btScalar scale, TVStack &force)
virtual void | addScaledElasticForce (btScalar scale, TVStack &force)
virtual void | addScaledDampingForceDifferential (btScalar scale, const TVStack &dv, TVStack &df)
virtual void | buildDampingForceDifferentialDiagonal (btScalar scale, TVStack &diagA)
virtual double | totalElasticEnergy (btScalar dt)
virtual double | totalDampingEnergy (btScalar dt)
virtual void | addScaledElasticForceDifferential (btScalar scale, const TVStack &dx, TVStack &df)
void | setMousePos (const btVector3 &p)
virtual btDeformableLagrangianForceType | getForceType ()
Public Member Functions inherited from btDeformableLagrangianForce
| btDeformableLagrangianForce ()
virtual | ~btDeformableLagrangianForce ()
virtual void | addScaledForces (btScalar scale, TVStack &force)=0
virtual void | addScaledDampingForceDifferential (btScalar scale, const TVStack &dv, TVStack &df)=0
virtual void | buildDampingForceDifferentialDiagonal (btScalar scale, TVStack &diagA)=0
virtual void | addScaledElasticForceDifferential (btScalar scale, const TVStack &dx, TVStack &df)=0
virtual void | addScaledExplicitForce (btScalar scale, TVStack &force)=0
virtual void | addScaledDampingForce (btScalar scale, TVStack &force)=0
virtual void | addScaledHessian (btScalar scale)
virtual btDeformableLagrangianForceType | getForceType ()=0
virtual void | reinitialize (bool nodeUpdated)
virtual int | getNumNodes ()
virtual void | addSoftBody (btSoftBody *psb)
virtual void | removeSoftBody (btSoftBody *psb)
virtual void | setIndices (const btAlignedObjectArray< btSoftBody::Node * > *nodes)
virtual btMatrix3x3 | Ds (int id0, int id1, int id2, int id3, const TVStack &dx)
virtual btMatrix3x3 | DsFromVelocity (const btSoftBody::Node *n0, const btSoftBody::Node *n1, const btSoftBody::Node *n2, const btSoftBody::Node *n3)
virtual void | testDerivative ()
virtual void | testHessian ()
virtual double | totalElasticEnergy (btScalar dt)
virtual double | totalDampingEnergy (btScalar dt)
virtual double | totalEnergy (btScalar dt)

## Private Attributes
btScalar | m_elasticStiffness
btScalar | m_dampingStiffness
const btSoftBody::Face & | m_face
btVector3 | m_mouse_pos
btScalar | m_maxForce

## Additional Inherited Members
Public Attributes inherited from btDeformableLagrangianForce
btAlignedObjectArray< btSoftBody * > | m_softBodies
const btAlignedObjectArray< btSoftBody::Node * > * | m_nodes

## Detailed Description

Definition at line 21 of file btDeformableMousePickingForce.h.

## Member Typedef Documentation

## ◆ TVStack

typedef btAlignedObjectArray<btVector3> btDeformableMousePickingForce::TVStack

Definition at line 31 of file btDeformableMousePickingForce.h.

## Constructor & Destructor Documentation

## ◆ btDeformableMousePickingForce()

btDeformableMousePickingForce::btDeformableMousePickingForce | ( | btScalar | k,
|  | btScalar | d,
|  | const btSoftBody::Face & | face,
|  | const btVector3 & | mouse_pos,
|  | btScalar | maxForce = `0.3`
| ) |  |
| inline

Definition at line 32 of file btDeformableMousePickingForce.h.

## Member Function Documentation

## ◆ addScaledDampingForce()

virtual void btDeformableMousePickingForce::addScaledDampingForce | ( | btScalar | scale,
|  | TVStack & | force
| ) |  |
| inlinevirtual

Implements btDeformableLagrangianForce.

Definition at line 47 of file btDeformableMousePickingForce.h.

## ◆ addScaledDampingForceDifferential()

virtual void btDeformableMousePickingForce::addScaledDampingForceDifferential | ( | btScalar | scale,
|  | const TVStack & | dv,
|  | TVStack & | df
| ) |  |
| inlinevirtual

Implements btDeformableLagrangianForce.

Definition at line 78 of file btDeformableMousePickingForce.h.

## ◆ addScaledElasticForce()

virtual void btDeformableMousePickingForce::addScaledElasticForce | ( | btScalar | scale,
|  | TVStack & | force
| ) |  |
| inlinevirtual

Definition at line 62 of file btDeformableMousePickingForce.h.

## ◆ addScaledElasticForceDifferential()

virtual void btDeformableMousePickingForce::addScaledElasticForceDifferential | ( | btScalar | scale,
|  | const TVStack & | dx,
|  | TVStack & | df
| ) |  |
| inlinevirtual

Implements btDeformableLagrangianForce.

Definition at line 129 of file btDeformableMousePickingForce.h.

## ◆ addScaledExplicitForce()

virtual void btDeformableMousePickingForce::addScaledExplicitForce | ( | btScalar | scale,
|  | TVStack & | force
| ) |  |
| inlinevirtual

Implements btDeformableLagrangianForce.

Definition at line 42 of file btDeformableMousePickingForce.h.

## ◆ addScaledForces()

virtual void btDeformableMousePickingForce::addScaledForces | ( | btScalar | scale,
|  | TVStack & | force
| ) |  |
| inlinevirtual

Implements btDeformableLagrangianForce.

Definition at line 36 of file btDeformableMousePickingForce.h.

## ◆ buildDampingForceDifferentialDiagonal()

virtual void btDeformableMousePickingForce::buildDampingForceDifferentialDiagonal | ( | btScalar | scale,
|  | TVStack & | diagA
| ) |  |
| inlinevirtual

Implements btDeformableLagrangianForce.

Definition at line 93 of file btDeformableMousePickingForce.h.

## ◆ getForceType()

virtual btDeformableLagrangianForceType btDeformableMousePickingForce::getForceType | ( |  | ) |
| inlinevirtual

Implements btDeformableLagrangianForce.

Definition at line 156 of file btDeformableMousePickingForce.h.

## ◆ setMousePos()

void btDeformableMousePickingForce::setMousePos | ( | const btVector3 & | p | ) |
| inline

Definition at line 151 of file btDeformableMousePickingForce.h.

## ◆ totalDampingEnergy()

virtual double btDeformableMousePickingForce::totalDampingEnergy | ( | btScalar | dt | ) |
| inlinevirtual

Reimplemented from btDeformableLagrangianForce.

Definition at line 112 of file btDeformableMousePickingForce.h.

## ◆ totalElasticEnergy()

virtual double btDeformableMousePickingForce::totalElasticEnergy | ( | btScalar | dt | ) |
| inlinevirtual

Reimplemented from btDeformableLagrangianForce.

Definition at line 95 of file btDeformableMousePickingForce.h.

## Member Data Documentation

## ◆ m_dampingStiffness

btScalar btDeformableMousePickingForce::m_dampingStiffness
| private

Definition at line 25 of file btDeformableMousePickingForce.h.

## ◆ m_elasticStiffness

btScalar btDeformableMousePickingForce::m_elasticStiffness
| private

Definition at line 25 of file btDeformableMousePickingForce.h.

## ◆ m_face

const btSoftBody::Face& btDeformableMousePickingForce::m_face
| private

Definition at line 26 of file btDeformableMousePickingForce.h.

## ◆ m_maxForce

btScalar btDeformableMousePickingForce::m_maxForce
| private

Definition at line 28 of file btDeformableMousePickingForce.h.

## ◆ m_mouse_pos

btVector3 btDeformableMousePickingForce::m_mouse_pos
| private

Definition at line 27 of file btDeformableMousePickingForce.h.

The documentation for this class was generated from the following file:

- btDeformableMousePickingForce.h